import { Entity } from "./Entity";
import { EntityListener } from "../@interfaces/EntityListener";
import { ImmutableArray } from "../utils/ImmutableArray";
export declare class EntityManager<E extends Entity = Entity> {
    private entities;
    private entitySet;
    private immutableEntities;
    private listener;
    constructor(listener: EntityListener);
    /**
     * Добавление новой сущности {@link Entity} в движок.
     * @param entity {@link Entity}
     */
    addEntity(entity: E): void;
    /**
     * Удаление сущности {@link Entity} из движка.
     * @param entity
     */
    removeEntity(entity: E): void;
    /**
     * Удаление всех сущностей.
     */
    removeAllEntities(): void;
    /**
     * Получить все сущности.
     */
    getEntities(): ImmutableArray<E>;
    /**
     * Добавление нового объекта {@link Entity}. Выбрасывает ошибку, если объект уже зарегистрирован.
     * @param entity объект Сущности.
     */
    protected addEntityInternal(entity: E): void;
    protected removeEntityInternal(entity: E): void;
}
