import { EntityListener } from "../@interfaces/EntityListener";
import { ImmutableArray } from "../utils/ImmutableArray";
import { Entity } from "./Entity";
import { Family } from "./Family";
export declare class FamilyManager<E extends Entity = Entity> {
    private readonly entities;
    private families;
    private immutableFamilies;
    private entityListeners;
    private entityListenerMasks;
    private _notifying;
    constructor(entities: ImmutableArray<E>);
    getEntitiesFor(family: Family): ImmutableArray<E>;
    notifying(): boolean;
    addEntityListener(family: Family, priority: number, listener: EntityListener): void;
    registerFamily(family: Family): ImmutableArray<E>;
    removeEntityListener(listener: EntityListener): void;
    updateFamilyMembership(entity: E): void;
}
